<template>
    <div class="content">

        <Userlist :contacts="contacts" @selected="startConversationWith"/>
        <MessageContact :messages="messages" :contact="selectedContact"  @new="newMessageSave"/>
        <Calling v-if="callingStatus" @callStatus="AnswerOrNot"/>
    </div>
</template>

<script>
    import Userlist from './Userlist'
    import MessageContact from './MessageContact'
    import Calling from './Calling'
    import Pusher from 'pusher-js';
    const APP_KEY='a98dc9b6ff7c0653405f';
    export default {
        props:{
            user:{
                type: Object,
                required: true,
            }
        },
        data(){
            return {
                selectedContact: null,
                messages:[],
                contacts:[],
                callingStatus:false,
            }
        },
        mounted() {
            Echo.private(`calling.${this.user.id}`)
                .listen('CallEvent',(e)=>{
                    this.callshow();
                });
            Echo.private(`messages.${this.user.id}`)
                .listen('MessageEvent',(e)=>{
                    this.handleIncomingMessage(e.message);
                });
            axios.get('contacts').then((response)=>{
                this.contacts=response.data;
            });
            this.setupPusher();
            this.callTo = this.callTo.bind(this);
            this.setupPusher = this.setupPusher.bind(this);
            this.startPeer = this.startPeer.bind(this);
        },
        methods:{
            startConversationWith(contact){
                this.updateUnreadCount(contact, true);
                axios.get(`/get/message/${contact.id}`)
                    .then((response) =>{
                        this.messages = response.data;
                        this.selectedContact = contact;
                    });
            },
            newMessageSave(message){
                this.messages.push(message);
            },
            handleIncomingMessage(message){
                if (this.selectedContact && message.from === this.selectedContact.id){
                    this.newMessageSave(message);
                    return;
                }
                this.updateUnreadCount(message.from_contact, false);
            },
            updateUnreadCount(contact, reset) {
                this.contacts = this.contacts.map((single) => {
                    if (single.id !== contact.id) {
                        return single;
                    }

                    if (reset)
                        single.unread = 0;
                    else
                        single.unread += 1;

                    return single;
                });
            },
            setupPusher(){
                this.pusher= new Pusher(APP_KEY,{
                    authEndpoint: '/pusher/auth',
                    cluster:'ap2',
                    auth:{
                        params: this.user.id,
                        headers:{
                            'X-CSRF-Token': window.csrfToken
                        }
                    }
                });
                this.channel = this.pusher.subscribe('presence-video-channel');
                //this.online.push(this.user);
                this.channel.bind(`client-signal-${this.user.id}`,(signal)=>{
                    let peer = this.peers[signal.userId];
                    // if peer is not already exists, we got an incoming call
                    if(peer === undefined) {
                        this.otherUserId=signal.userId;
                        peer = this.startPeer(signal.userId, false);
                    }
                    peer.signal(signal.data);
                });
            },
            callshow(){
                this.callingStatus = true;
                //window.open('/','Calling');
                //document.getElementById('call').modal('show');
            },
            AnswerOrNot(status){
                if (status === 1){
                    this.callingStatus = false;
                    window.open('video');
                }else {
                    this.callingStatus = false;
                }
            },
        },
        components: {Calling,Userlist,MessageContact}
    }
</script>
